using CarCenterBusinessLogic.BusinessLogics;
using CarCenterBusinessLogic.MailWorker;
using CarCenterBusinessLogic.OfficePackage;
using CarCenterBusinessLogic.OfficePackage.Implements;
using CarCenterContracts.BindingModels;
using CarCenterContracts.BusinessLogicsContracts;
using CarCenterContracts.StoragesContracts;
using CarCenterDataBaseImplement.Implements;
using CarCenterDataBaseImplement.Implemets;
using Microsoft.OpenApi.Models;

var builder = WebApplication.CreateBuilder(args);

builder.Logging.SetMinimumLevel(LogLevel.Trace);
builder.Logging.AddLog4Net("log4net.config");

// Add services to the container.

builder.Services.AddTransient<IManagerStorage, ManagerStorage>();
builder.Services.AddTransient<IPreSaleWorkStorage, PreSaleWorkStorage>();
builder.Services.AddTransient<ISaleStorage, SaleStorage>();
builder.Services.AddTransient<IEmployeeStorage, EmployeeStorage>();

builder.Services.AddTransient<IManagerLogic, ManagerLogic>();
builder.Services.AddTransient<IPreSaleWorkLogic, PreSaleWorkLogic>();
builder.Services.AddTransient<ISaleLogic, SaleLogic>();
builder.Services.AddTransient<IEmployeeLogic, EmployeeLogic>();

builder.Services.AddTransient<IAdministratorStorage, AdministratorStorage>();
builder.Services.AddTransient<ICarStorage, CarStorage>();
builder.Services.AddTransient<IEquipmentStorage, EquipmentStorage>();
builder.Services.AddTransient<IInspectionStorage, InspectionStorage>();

builder.Services.AddTransient<IAdministratorLogic, AdministratorLogic>();
builder.Services.AddTransient<ICarLogic, CarLogic>();
builder.Services.AddTransient<IEquipmentLogic, EquipmentLogic>();
builder.Services.AddTransient<IInspectionLogic, InspectionLogic>();

builder.Services.AddTransient<IReportLogicAdministrator, ReportLogicAdministrator>();
builder.Services.AddTransient<AbstractSaveToPdfAdministrator, SaveToPdfAdministrator>();
builder.Services.AddSingleton<AbstractMailWorker, MailKitWorker>();

builder.Services.AddTransient<AbstractSaveToExcelAdministrator, SaveToExcelAdministrator>();
builder.Services.AddTransient<AbstractSaveToWordAdministrator, SaveToWordAdministrator>();
builder.Services.AddTransient<AbstractSaveToPdfAdministrator, SaveToPdfAdministrator>();



builder.Services.AddControllers();
// Learn more about configuring Swagger/OpenAPI at https://aka.ms/aspnetcore/swashbuckle
builder.Services.AddEndpointsApiExplorer();
builder.Services.AddSwaggerGen(c =>
{
    c.SwaggerDoc("v1", new OpenApiInfo
    {
        Title = "CarCenterRestApi",
        Version = "v1"
    });
});

var app = builder.Build();


var mailSender = app.Services.GetService<AbstractMailWorker>();
mailSender?.MailConfig(new MailConfigBindingModel
{
    MailLogin = builder.Configuration?.GetSection("MailLogin")?.Value?.ToString()
?? string.Empty,
    MailPassword =
builder.Configuration?.GetSection("MailPassword")?.Value?.ToString() ??
string.Empty,
    SmtpClientHost =
builder.Configuration?.GetSection("SmtpClientHost")?.Value?.ToString() ??
string.Empty,
    SmtpClientPort =
Convert.ToInt32(builder.Configuration?.GetSection("SmtpClientPort")?.Value?.ToString()),
    PopHost = builder.Configuration?.GetSection("PopHost")?.Value?.ToString() ??
string.Empty,
    PopPort = Convert.ToInt32(builder.Configuration?.GetSection("PopPort")?.Value?.ToString())
});



// Configure the HTTP request pipeline.
if (app.Environment.IsDevelopment())
{
    app.UseSwagger();
    app.UseSwaggerUI(c => c.SwaggerEndpoint("/swagger/v1/swagger.json", "CarCenterRestApi v1"));
}

app.UseHttpsRedirection();

app.UseAuthorization();

app.MapControllers();

app.Run();
